//Gravel Model of human expansion
//setup a chromosome of 10001 bp that will undergo neutral mutations of type m1 in a single genomic element. The mutation rate is derived from the empirical data

initialize() {
	initializeMutationRate(2.36e-8);
	initializeMutationType("m1",0.5, "f", 0.0); //neutral mutations
	initializeGenomicElementType("g1", m1, 1.0); //all the genome undergoing neutral 
	initializeGenomicElement(g1,0,10000); //genome size of 10001 bp (chromosome length)
	initializeRecombinationRate(1e-8);
}
//------------------------------------------------------------------
//Model the African demography
//straightforward, initial supopulation of size 7310, an expansion to size 14474 in generation 52080 and a steady state continuation to the present, generation 58000. These are effective population sizes given random panmictic mating in a Wright-Fisher model, the actual population sizes are larger. These population sizes are large (will take a lot of time to run) hence supopulation sizes are scaled down by 10x
//if you rescale the model then one would also involve rescaling the mutation rate, recombination rate, selection coefficients and time, see the manual), here the artificial clipping is done for the exploration purposes.

1 {sim.addSubpop("p1", 731);} //ancestral African
//expand the African population to 14474 
//this occurs 148000 years (5920 generations) ago.
52080 {p1.setSubpopulationSize(1447);}
//generation 58000 is the present. Output and terminate.
58000 late(){
	p1.outputSample(216); //YRI phase 3 sample of size 108
	p2.outputSample(198);
	p3.outputSample(206);
}

//-------------------------------------------------------------------
//Model the non-African colonization event
// split the non-Africans from Africans in generation 55960 (subpopulation size is scaled down by a factor of 10x)

//split non-Africans and set up migration between them 
//this occurs 51000 years (2040 generations) ago
55960 {
	sim.addSubpopSplit("p2", 186, p1); //p2 is derived from p1 and added, clonal copies of p1 added to p2 (randombly drawn, founder effect)
	//set same rate of migration events between two sub-populations
	p1.setMigrationRates(p2,15e-5);
	p2.setMigrationRates(p1,15e-5);
}
//-------------------------------------------------------------------
//Model European / East Asian split
//split p2 into European and East Asian subpopulation
// this occurs 23000 years (920 generations) ago
57080 {
	sim.addSubpopSplit("p3", 55, p2);
	p2.setSubpopulationSize(103); //reduce European size
	
	//set migration rates for the rest of the simulation
	p1.setMigrationRates(c(p2,p3), c(2.5e-5, 0.78e-5)); // with p2 and p3
	p2.setMigrationRates(c(p1,p3), c(2.5e-5, 3.11e-5)); //with p1 and p3
	p3.setMigrationRates(c(p1,p2), c(0.78e-5, 3.11e-5)); //with p1 and p2
}
//-------------------------------------------------------------------
//Model the European / East Asian population expansion
//set up exponential growth in Europe and east Asia
//N(0) is the base subpopulation size and t = gen -57080
// N(Europe) shoudl be int(round(N(0) * e^(0.0038*t)))
//N(East Asia) should be int(round(N(0) * e^(0.0048*t)))

57080:58000 {
	t = sim.generation -57080;
	p2_size = round(103 * exp(0.0038 *t));
	p3_size = round(55 * exp(0.0048 *t));
	
	p2.setSubpopulationSize(asInteger(p2_size));
	p3.setSubpopulationSize(asInteger(p3_size));
}

//---------------------------------------------------------------------
//THIS IS HYPOTHETICAL SCNEARIO
//in 58001 generation all the world subpopulations came together and formed a giant super-population p4, which means that p1,p2 and p3 cease to exist as separate entity (therefore in late() event the subpopulation size for p1, p2 and p3 is set to 0)

58001 early() {
	sim.addSubpop("p4", 9000);
	p4.setMigrationRates(c(p1,p2,p3),c(0.3,0.4,0.3));
}
58001 late() {
	c(p1,p2,p3).setSubpopulationSize(0);
}
//----------------------------------------------------------------------
//Exercise 1.
//Mars colony in 58010, new subpopulation p5 that split from p4 with an initial size of 10,
//beginning generation 58012 have its size double in each generation until generation 58020 and then it stabilizes. on Mars sexual reproductin is prevented and they reproduce clonally instead.
//p5.setCloningRate(1.0) to put this into effect immediately after p5 is created.

58010 early() {
	sim.addSubpopSplit("p5", 10, p4);
	p5.setCloningRate(1.0);
	p5.setMigrationRates(p4,0);
}
58010:58012 {
	p5.setSubpopulationSize(15);
}

58012:58020 {
	//p5.setSubpopulationSize(15);
	t2 = (sim.generation - 58012)+1; //+1 is necessary otherwise p5_size will be 0 and the p5 will be destroyed.
	
	p5_size = (15 * (2 * t2));
	print(p5_size);
	p5.setSubpopulationSize(asInteger(p5_size));
}
580
/*58020 late(){
	p5.outputSample(p5_size);
	p4.outputSample(9000);

}
*/


